--- a/arch/arm/boot/dts/qcom-ipq4019-ap.dk04.1.dtsi
+++ b/arch/arm/boot/dts/qcom-ipq4019-ap.dk04.1.dtsi
@@ -17,53 +17,79 @@
 		stdout-path = "serial0:115200n8";
 	};
 
-	memory {
-		device_type = "memory";
-		reg = <0x80000000 0x10000000>; /* 256MB */
-	};
-
 	soc {
+		rng@22000 {
+			status = "okay";
+		};
+
 		pinctrl@1000000 {
 			serial_0_pins: serial0-pinmux {
-				pins = "gpio16", "gpio17";
-				function = "blsp_uart0";
-				bias-disable;
+				mux {
+					pins = "gpio16", "gpio17";
+					function = "blsp_uart0";
+					bias-disable;
+				};
 			};
 
 			serial_1_pins: serial1-pinmux {
-				pins = "gpio8", "gpio9",
-					"gpio10", "gpio11";
-				function = "blsp_uart1";
-				bias-disable;
+				mux {
+					pins = "gpio8", "gpio9";
+					function = "blsp_uart1";
+					bias-disable;
+				};
 			};
 
 			spi_0_pins: spi-0-pinmux {
 				pinmux {
 					function = "blsp_spi0";
 					pins = "gpio13", "gpio14", "gpio15";
-					bias-disable;
 				};
 				pinmux_cs {
 					function = "gpio";
 					pins = "gpio12";
+				};
+				pinconf {
+					pins = "gpio13", "gpio14", "gpio15";
+					drive-strength = <12>;
+					bias-disable;
+				};
+				pinconf_cs {
+					pins = "gpio12";
+					drive-strength = <2>;
 					bias-disable;
 					output-high;
 				};
 			};
 
 			i2c_0_pins: i2c-0-pinmux {
-				pins = "gpio20", "gpio21";
-				function = "blsp_i2c0";
-				bias-disable;
+				pinmux {
+					function = "blsp_i2c0";
+					pins = "gpio10", "gpio11";
+				};
+				pinconf {
+					pins = "gpio10", "gpio11";
+					drive-strength = <16>;
+					bias-disable;
+				};
 			};
 
 			nand_pins: nand-pins {
-				pins = "gpio53", "gpio55", "gpio56",
-					"gpio57", "gpio58", "gpio59",
-					"gpio60", "gpio62", "gpio63",
-					"gpio64", "gpio65", "gpio66",
-					"gpio67", "gpio68", "gpio69";
-				function = "qpic";
+				pullups {
+					pins = "gpio52", "gpio53", "gpio58",
+						"gpio59";
+					function = "qpic";
+					bias-pull-up;
+				};
+
+				pulldowns {
+					pins = "gpio54", "gpio55", "gpio56",
+						"gpio57", "gpio60", "gpio61",
+						"gpio62", "gpio63", "gpio64",
+						"gpio65", "gpio66", "gpio67",
+						"gpio68", "gpio69";
+					function = "qpic";
+					bias-pull-down;
+				};
 			};
 		};
 
@@ -89,11 +115,11 @@
 			status = "okay";
 			cs-gpios = <&tlmm 12 0>;
 
-			m25p80@0 {
+			mx25l25635e@0 {
 				#address-cells = <1>;
 				#size-cells = <1>;
 				reg = <0>;
-				compatible = "n25q128a11";
+				compatible = "mx25l25635e";
 				spi-max-frequency = <24000000>;
 			};
 		};
@@ -102,6 +128,45 @@
 			status = "okay";
 			perst-gpio = <&tlmm 38 0x1>;
 		};
+
+		i2c0: i2c@78b7000 { /* BLSP1 QUP2 */
+			pinctrl-0 = <&i2c_0_pins>;
+			pinctrl-names = "default";
+
+			status = "okay";
+		};
+
+		usb3_ss_phy: ssphy@9a000 {
+			status = "okay";
+		};
+
+		usb3_hs_phy: hsphy@a6000 {
+			status = "okay";
+		};
+
+		usb3: usb3@8af8800 {
+			status = "okay";
+		};
+
+		usb2_hs_phy: hsphy@a8000 {
+			status = "okay";
+		};
+
+		usb2: usb2@60f8800 {
+			status = "okay";
+		};
+
+		cryptobam: dma@8e04000 {
+			status = "okay";
+		};
+
+		crypto@8e3a000 {
+			status = "okay";
+		};
+
+		watchdog@b017000 {
+			status = "okay";
+		};
 	};
 };
 
